#include "launcher.h"

#include <QDebug>
#include <QObject>
#include <QWidget>
#include <QDir>
#include <QCoreApplication>
#include <QString>
#include <QList>

#include "forge1.12.2/getArgs.h"


Launcher::Launcher(QObject *mainwindow) : QObject(mainwindow), process(new QProcess(this)), mainwindow(mainwindow), get_args(new getArgs()) {
    // Подключение сигналов для отладки
	/*
	connect(process, &QProcess::readyReadStandardOutput, [this]() {
        qDebug() << "Standard Output: " << process->readAllStandardOutput();
    });

    connect(process, &QProcess::readyReadStandardError, [this]() {
        qDebug() << "Standard Error: " << process->readAllStandardError();
    });

    connect(process, QOverload<int, QProcess::ExitStatus>::of(&QProcess::finished),
            [this](int exitCode, QProcess::ExitStatus status) {
                qDebug() << "Process finished with exit code:" << exitCode
                         << "and status:" << status;
    });
	*/
}

Launcher::~Launcher() {
    delete process;
}

void Launcher::startProcess(
		QString &workingDir, 
		QString &executablePath, 
		QString &RAM, 
		QString &username, 
		QString &uuid, 
		QString &access_token,
		QString garbarge_collector) {
	QStringList arguments = get_args->getCrossPlatformArgs(RAM, username, uuid, access_token, garbarge_collector);

    process->setWorkingDirectory(workingDir);
    process->start(executablePath, arguments);

    if (!process->waitForStarted()) {
        qDebug() << "Failed to start process";
        qDebug() << process->errorString();
        return;
    }

	QWidget *mainwindowWidget = qobject_cast<QWidget*>(mainwindow);

	// Скрытие лаунчера при запуске
	connect(process,
		QOverload<int, QProcess::ExitStatus>::of(&QProcess::finished),
		[mainwindowWidget](int, QProcess::ExitStatus) { mainwindowWidget->show(); });

	if (mainwindowWidget) {
		mainwindowWidget->hide();
	} else {
		qDebug() << "Parent object is not a QWidget.";
	}
    qDebug() << "Process started successfully";
}
